#!/bin/sh
###
### 0 Subprogram Section Begin
###

v_start_time=$(date +%"s")
sub_confirm() {
        #
        # Sub_answer begin:
        #
        # Written by a RHCE, Tang Bo. Report Bugs to "tangbo@fjirsm.ac.cn".
        # Version 1.1.1. Last modified on Jan 13rd 2007:
        # 1.0   Original
        # 1.1   Introduce "sub_sub_answer()"
        # 1.1.1 "BFS1(Bash Format Standard V1)" applied
        sub_answer() {
                unset SUBANS
                #
                # Sub_sub_answer begin:
                #
                # Written by a RHCE, Tang Bo. Report Bugs to "tangbo@fjirsm.ac.cn".
                # Version 1.0. Last modified on Jan 13rd 2007:
                # 1.0   Original
                sub_sub_answer(){
                        SUBANS=`echo $SUBANS |tr -d "[:blank:]"`
                        if [ -z $SUBANS ]
                        then
                        SUBANS="NULL"
                        fi
                }
                #
                # Sub_sub_answer end.
                #
                read -p "$1" SUBANS
                sub_sub_answer # Line15
                # Line15 begin: Deal with $SUNANS:
                until [ $SUBANS ==  "y"  -o  $SUBANS ==  "n" ]
                do
                        echo "This question should be answered either with \"y\" or \"n\"."
                        read -p "$1" SUBANS
                        sub_sub_answer
                done
                # Line15 end.
        }
        #
        # Sub_answer end.
        #
        unset SUBCON1
        unset SUBCON2
        SUBCON1=0
        SUBCON2=1
        until [ $(echo $SUBCON1|tr -d "[:blank:]")  == $(echo $SUBCON2|tr -d "[:blank:]") ]
        do
                read -p "$1" SUBCON1
                sub_answer "Your input is: \"$SUBCON1\". Are you sure ?(y/n) "
                if [ -z $(echo $SUBCON1|tr -d "[:blank:]") ]
                then
                 SUBCON1="NULL"
                fi
                if [ $SUBANS == "y" ]
                then
                SUBCON2=$SUBCON1
                fi
        done
}

v_dbname=`cat /home/oracle/dbname 2>/dev/null | tr -d [:blank:]`
v_first_node=`cat /home/oracle/nodeinfo 2>/dev/null | head -n 1`
v_second_node=`cat /home/oracle/nodeinfo 2>/dev/null | tail -n 1`

###
### 0 Subprogram Section End
### 1 Main Section Begin
###

# 1 Decision Root or Oracle Begin

if [ $(id -u) == 0 ]
then 
 echo "Please login as oracle NOT root."
 exit
fi

# 1 Decision Root or Oracle End
# 2 Stop DB Begin

if [ -f /u01/app/11.2.0/grid/dbs/hc_+ASM1.dat ]
then
 if [ -z $v_dbname ]
 then
  sub_confirm "Please specify the database name: ? " 
  v_dbname=$SUBCON1
  echo $v_dbname>/home/oracle/dbname
 fi
 if [ -z $v_first_node ]
 then
  sub_confirm "Please specify the first node name: ? " 
  v_first_node=$SUBCON1
 fi
 if [ -z $v_second_node ]
 then
  sub_confirm "Please specify the second node name: ? " 
  v_second_node=$SUBCON1
 fi
 srvctl stop instance -d $v_dbname -i ${v_dbname}1
 sudo /u01/app/11.2.0/grid/bin/crs_stat -t
 srvctl stop instance -d $v_dbname -i ${v_dbname}2
 sudo /u01/app/11.2.0/grid/bin/crs_stat -t
 sudo /u01/app/11.2.0/grid/bin/crsctl stop has
 ssh $v_second_node "sudo /u01/app/11.2.0/grid/bin/crsctl stop has"
 echo "Please wait ......"
 sleep 60
fi
/usr/bin/stopdb &>/dev/null 

# 2 Stop DB End
# 3 Man Directory Begin

if [ -f /u01/app/11.2.0/grid/dbs/hc_+ASM1.dat ]
then
 if [ ! -d /u01/data/backup ]
 then
  sub_confirm "Please input the full path of directory to hold the 11 rawdevices backup of RAC, need about 18G ( oracle user should have !!!WRITE PERMISSION!!! in it): ? "
 else
  SUBCON1=/u01/data
 fi
  rm -rf  $SUBCON1/backup 2>/dev/null
  mkdir -p $SUBCON1/backup 2>/dev/null
  chown oracle:oinstall $SUBCON1/backup
fi
#rm -rf /u01/app/oracle/man_recovery_area/orcl/backup/
mkdir -p /u01/app/oracle/man_recovery_area/orcl 2>/dev/null

# 3 Man Directory End
# 4 Backup Important Begin

if [ -f /u01/app/11.2.0/grid/dbs/hc_+ASM1.dat ]
then
 for i in `ls /dev/oracleasm/disks`
 do
  dd if=/dev/oracleasm/disks/$i of=$SUBCON1/backup/$i.img bs=4M count=300&
 done
 wait
fi

# 4 Backup Important End
# 5 Backup Miscellaneous Begin

# 5 Backup Miscellaneous End
# 6 Start DB Begin

if [ -f /u01/app/11.2.0/grid/dbs/hc_+ASM1.dat ]
then
 sudo /u01/app/11.2.0/grid/bin/crsctl start has
 ssh $v_second_node "sudo /u01/app/11.2.0/grid/bin/crsctl start has"
 v_end_time=$(date +%"s")
 echo "总共花了：$[ $v_end_time - $v_start_time ]秒。再等90秒为你启动集群。"
 sleep 90
 sudo /u01/app/11.2.0/grid/bin/crsctl start resource ora.DATA.dg
 sudo /u01/app/11.2.0/grid/bin/crsctl start resource ora.FRA.dg
 srvctl start database -d $v_dbname
 sudo /u01/app/11.2.0/grid/bin/crs_stat -t
fi


# 6 End DB End
### 1 Main Section Begin
###
