#!/bin/sh
###
### 0 Subprogram Section Begin
###

v_start_time=$(date +%"s")
sub_confirm() {
        #
        # Sub_answer begin:
        #
        # Written by a RHCE, Tang Bo. Report Bugs to "tangbo@fjirsm.ac.cn".
        # Version 1.1.1. Last modified on Jan 13rd 2007:
        # 1.0   Original
        # 1.1   Introduce "sub_sub_answer()"
        # 1.1.1 "BFS1(Bash Format Standard V1)" applied
        sub_answer() {
                unset SUBANS
                #
                # Sub_sub_answer begin:
                #
                # Written by a RHCE, Tang Bo. Report Bugs to "tangbo@fjirsm.ac.cn".
                # Version 1.0. Last modified on Jan 13rd 2007:
                # 1.0   Original
                sub_sub_answer(){
                        SUBANS=`echo $SUBANS |tr -d "[:blank:]"`
                        if [ -z $SUBANS ]
                        then
                        SUBANS="NULL"
                        fi
                }
                #
                # Sub_sub_answer end.
                #
                read -p "$1" SUBANS
                sub_sub_answer # Line15
                # Line15 begin: Deal with $SUNANS:
                until [ $SUBANS ==  "y"  -o  $SUBANS ==  "n" ]
                do
                        echo "This question should be answered either with \"y\" or \"n\"."
                        read -p "$1" SUBANS
                        sub_sub_answer
                done
                # Line15 end.
        }
        #
        # Sub_answer end.
        #
        unset SUBCON1
        unset SUBCON2
        SUBCON1=0
        SUBCON2=1
        until [ $(echo $SUBCON1|tr -d "[:blank:]")  == $(echo $SUBCON2|tr -d "[:blank:]") ]
        do
                read -p "$1" SUBCON1
                sub_answer "Your input is: \"$SUBCON1\". Are you sure ?(y/n) "
                if [ -z $(echo $SUBCON1|tr -d "[:blank:]") ]
                then
                 SUBCON1="NULL"
                fi
                if [ $SUBANS == "y" ]
                then
                SUBCON2=$SUBCON1
                fi
        done
}

v_dbname=`cat /home/oracle/dbname 2>/dev/null | tr -d [:blank:]`
v_first_node=`cat /home/oracle/nodeinfo 2>/dev/null | head -n 1`
v_second_node=`cat /home/oracle/nodeinfo 2>/dev/null | tail -n 1`

###
### 0 Subprogram Section End
### 1 Main Section Begin
###

# 1 Decision Root or Oracle Begin

if [ $(id -u) == 0 ]
then
 echo "Please login as oracle NOT root."
 exit
fi

# 1 Decision Root or Oracle End
# 2 Stop DB Begin

if [ -f /u01/app/11.2.0/grid/dbs/hc_+ASM1.dat ]
then
 v_dbname=`cat /home/oracle/dbname | tr -d [:blank:]`
 v_first_node=`cat /home/oracle/nodeinfo | head -n 1 | tr -d [:blank:]`
 v_second_node=`cat /home/oracle/nodeinfo | tail -n 1 | tr -d [:blank:]`
 srvctl stop instance -d $v_dbname -i ${v_dbname}1 -o abort
 sudo /u01/app/11.2.0/grid/bin/crs_stat -t
 srvctl stop instance -d $v_dbname -i ${v_dbname}2 -o abort
 sudo /u01/app/11.2.0/grid/bin/crs_stat -t
 sudo /u01/app/11.2.0/grid/bin/crsctl stop has
 ssh $v_second_node "sudo /u01/app/11.2.0/grid/bin/crsctl stop has"
 echo "Please wait ......"
 sleep 60
fi

sqlplus /nolog <<EOF
conn / as sysdba
shutdown abort
quit
EOF

emctl stop dbconsole
# 2 Stop DB End
# 3 Delete Begin

# 3 Delete End
# 4 Recovery Begin

if [ -f /u01/app/11.2.0/grid/dbs/hc_+ASM1.dat ]
then
 if [ ! -d /u01/data/backup ]
 then
  sub_confirm "Please input the full path of directory to hold the 11 rawdevices backup of RAC, need about 18G: ? "
 else
  SUBCON1=/u01/data
 fi
 for i in `ls /dev/oracleasm/disks`
 do
  dd of=/dev/oracleasm/disks/$i if=$SUBCON1/backup/$i.img bs=4M&
 done
 wait
fi

# 4 Recovery End

if [ -f /u01/app/11.2.0/grid/dbs/hc_+ASM1.dat ]
then
 sudo /u01/app/11.2.0/grid/bin/crsctl start has
 ssh $v_second_node "sudo /u01/app/11.2.0/grid/bin/crsctl start has"
 v_end_time=$(date +%"s")
 echo "总共花了：$[ $v_end_time - $v_start_time ]秒。"
 sleep 90
 sudo /u01/app/11.2.0/grid/bin/crsctl start resource ora.DATA.dg
 sudo /u01/app/11.2.0/grid/bin/crsctl start resource ora.FRA.dg
 srvctl start database -d $v_dbname
 sudo /u01/app/11.2.0/grid/bin/crs_stat -t
fi


###
### 1 Main Section Begin
###
